=== debian/changelog ===
compute (0.4-3) unstable; urgency=medium

  * Install examples to doc package.
  * Add autopkgtest testsuite.
  * d/rules: remove unnecessary buildsystem parameter.
  * Install HTML documentation to doc package.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 03 Dec 2015 11:50:09 +0000

compute (0.4-2) unstable; urgency=medium

  * d/control: fix homepage. (Closes: #797308)
  * d/{control,copyright}: cme fixed.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 29 Oct 2015 11:11:41 +0000

compute (0.4-1) unstable; urgency=low

  * Initial release. (Closes: #794649)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 27 Jul 2015 11:11:49 +0100
