=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf bin doc/bin doc/html
	rm -f doc/*.jam doc/*.xml

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBOOST_COMPUTE_BUILD_BENCHMARKS=OFF \
		-DBOOST_COMPUTE_BUILD_EXAMPLES=OFF \
		-DBOOST_COMPUTE_BUILD_TESTS=OFF

override_dh_auto_build:
	dh_auto_build
	cd doc && \
	printf "using boostbook ;\nusing quickbook ;\nusing doxygen ;" >> ./user-config.jam  && \
	bjam --v2 --user-config=./user-config.jam html

override_dh_compress:
	dh_compress --exclude=examples
