## compute 0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,12 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 cmake_minimum_required(VERSION 2.8)
 
 project(BoostCompute)
@@ -14,8 +23,10 @@
 
 # optional support for c++11
 option(BOOST_COMPUTE_USE_CPP11 "Use C++11 features" OFF)
-if(${BOOST_COMPUTE_USE_CPP11})
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+if(NOT MSVC)
+  if(${BOOST_COMPUTE_USE_CPP11})
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+  endif()
 endif()
 
 # optional support for offline-caching
@@ -29,7 +40,13 @@
 if(${BOOST_COMPUTE_THREAD_SAFE})
   add_definitions(-DBOOST_COMPUTE_THREAD_SAFE)
   if(${BOOST_COMPUTE_USE_CPP11})
-    add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+    if(MSVC)
+      if (MSVC_VERSION GREATER 1800)
+        add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+      endif()
+    else()
+      add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+    endif()
   endif()
 endif()
 
@@ -40,6 +57,7 @@
 option(BOOST_COMPUTE_HAVE_VTK "Have VTK" OFF)
 option(BOOST_COMPUTE_HAVE_CUDA "Have CUDA" OFF)
 option(BOOST_COMPUTE_HAVE_TBB "Have TBB" OFF)
+option(BOOST_COMPUTE_HAVE_BOLT "Have BOLT" OFF)
 
 include_directories(include)
 
@@ -48,6 +66,12 @@
 endif()
 
 if(MSVC)
+  # optional support for boost dynamic libraries
+  option(BOOST_COMPUTE_BOOST_ALL_DYN_LINK "Use boost dynamic link libraries" OFF)
+  if(${BOOST_COMPUTE_BOOST_ALL_DYN_LINK})
+    add_definitions(-DBOOST_ALL_DYN_LINK)
+  endif()
+  link_directories(${Boost_LIBRARY_DIRS})
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
   add_definitions(-D_SCL_SECURE_NO_WARNINGS)
 endif()
@@ -81,7 +105,7 @@
 # install cmake config file
 install(
   FILES ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
-  DESTINATION share/cmake/BoostCompute
+  DESTINATION lib/cmake/BoostCompute
 )
 
 # install header files
