=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,12 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013-2014 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 include_directories(../include)
 
 set(EXAMPLES
@@ -86,7 +95,12 @@
   find_package(VTK REQUIRED)
   include(${VTK_USE_FILE})
   add_executable(opengl_sphere opengl_sphere.cpp)
-  target_link_libraries(opengl_sphere ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${VTK_LIBRARIES} GL)
+  target_link_libraries(opengl_sphere ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${VTK_LIBRARIES})
+  if(APPLE)
+    target_link_libraries(opengl_sphere "-framework OpenGL")
+  elseif(UNIX)
+    target_link_libraries(opengl_sphere GL)
+  endif()
 endif()
 
 # qt examples
@@ -134,6 +148,11 @@
   )
   foreach(EXAMPLE ${QT_OPENGL_EXAMPLES})
     add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
-    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES} GL)
+    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES})
+    if(APPLE)
+      target_link_libraries(${EXAMPLE} "-framework OpenGL")
+    elseif(UNIX)
+      target_link_libraries(${EXAMPLE} GL)
+    endif()
   endforeach()
 endif()
