=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,20 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 include_directories(../include)
 
 set(BOOST_COMPONENTS unit_test_framework)
+
+if(${BOOST_COMPUTE_USE_CPP11})
+  # allow tests to use C++11 features
+  add_definitions(-DBOOST_COMPUTE_USE_CPP11)
+endif()
 
 if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
   set(BOOST_COMPONENTS ${BOOST_COMPONENTS} system filesystem)
@@ -45,9 +59,6 @@
 add_compute_test("core.device" test_device.cpp)
 add_compute_test("core.event" test_event.cpp)
 add_compute_test("core.function" test_function.cpp)
-add_compute_test("core.image2d" test_image2d.cpp)
-add_compute_test("core.image3d" test_image3d.cpp)
-add_compute_test("core.image_sampler" test_image_sampler.cpp)
 add_compute_test("core.kernel" test_kernel.cpp)
 add_compute_test("core.pipe" test_pipe.cpp)
 add_compute_test("core.platform" test_platform.cpp)
@@ -57,6 +68,7 @@
 add_compute_test("core.user_event" test_user_event.cpp)
 
 add_compute_test("utility.extents" test_extents.cpp)
+add_compute_test("utility.invoke" test_invoke.cpp)
 add_compute_test("utility.program_cache" test_program_cache.cpp)
 add_compute_test("utility.wait_list" test_wait_list.cpp)
 
@@ -97,6 +109,7 @@
 add_compute_test("algorithm.random_fill" test_random_fill.cpp)
 add_compute_test("algorithm.random_shuffle" test_random_shuffle.cpp)
 add_compute_test("algorithm.reduce" test_reduce.cpp)
+add_compute_test("algorithm.reduce_by_key" test_reduce_by_key.cpp)
 add_compute_test("algorithm.remove" test_remove.cpp)
 add_compute_test("algorithm.replace" test_replace.cpp)
 add_compute_test("algorithm.reverse" test_reverse.cpp)
@@ -104,6 +117,7 @@
 add_compute_test("algorithm.rotate_copy" test_rotate_copy.cpp)
 add_compute_test("algorithm.scan" test_scan.cpp)
 add_compute_test("algorithm.scatter" test_scatter.cpp)
+add_compute_test("algorithm.scatter_if" test_scatter_if.cpp)
 add_compute_test("algorithm.search" test_search.cpp)
 add_compute_test("algorithm.search_n" test_search_n.cpp)
 add_compute_test("algorithm.set_difference" test_set_difference.cpp)
@@ -115,6 +129,7 @@
 add_compute_test("algorithm.stable_partition" test_stable_partition.cpp)
 add_compute_test("algorithm.stable_sort" test_stable_sort.cpp)
 add_compute_test("algorithm.transform" test_transform.cpp)
+add_compute_test("algorithm.transform_if" test_transform_if.cpp)
 add_compute_test("algorithm.transform_reduce" test_transform_reduce.cpp)
 add_compute_test("algorithm.unique" test_unique.cpp)
 add_compute_test("algorithm.unique_copy" test_unique_copy.cpp)
@@ -124,6 +139,7 @@
 add_compute_test("allocator.pinned_allocator" test_pinned_allocator.cpp)
 
 add_compute_test("async.wait" test_async_wait.cpp)
+add_compute_test("async.wait_guard" test_async_wait_guard.cpp)
 
 add_compute_test("container.array" test_array.cpp)
 add_compute_test("container.dynamic_bitset" test_dynamic_bitset.cpp)
@@ -135,8 +151,9 @@
 add_compute_test("container.valarray" test_valarray.cpp)
 add_compute_test("container.vector" test_vector.cpp)
 
+add_compute_test("exception.context_error" test_context_error.cpp)
+add_compute_test("exception.no_device_found" test_no_device_found.cpp)
 add_compute_test("exception.opencl_error" test_opencl_error.cpp)
-add_compute_test("exception.context_error" test_context_error.cpp)
 add_compute_test("exception.unsupported_extension" test_unsupported_extension.cpp)
 
 add_compute_test("functional.as" test_functional_as.cpp)
@@ -148,25 +165,34 @@
 add_compute_test("functional.popcount" test_functional_popcount.cpp)
 add_compute_test("functional.unpack" test_functional_unpack.cpp)
 
+add_compute_test("image.image1d" test_image1d.cpp)
+add_compute_test("image.image2d" test_image2d.cpp)
+add_compute_test("image.image3d" test_image3d.cpp)
+add_compute_test("image.image_sampler" test_image_sampler.cpp)
+
 add_compute_test("iterator.buffer_iterator" test_buffer_iterator.cpp)
 add_compute_test("iterator.constant_iterator" test_constant_iterator.cpp)
 add_compute_test("iterator.counting_iterator" test_counting_iterator.cpp)
 add_compute_test("iterator.discard_iterator" test_discard_iterator.cpp)
+add_compute_test("iterator.function_input_iterator" test_function_input_iterator.cpp)
 add_compute_test("iterator.permutation_iterator" test_permutation_iterator.cpp)
+add_compute_test("iterator.strided_iterator" test_strided_iterator.cpp)
 add_compute_test("iterator.transform_iterator" test_transform_iterator.cpp)
 add_compute_test("iterator.zip_iterator" test_zip_iterator.cpp)
 
+add_compute_test("memory.local_buffer" test_local_buffer.cpp)
 add_compute_test("memory.svm_ptr" test_svm_ptr.cpp)
 
 add_compute_test("random.bernoulli_distribution" test_bernoulli_distribution.cpp)
 add_compute_test("random.discrete_distribution" test_discrete_distribution.cpp)
 add_compute_test("random.linear_congruential_engine" test_linear_congruential_engine.cpp)
 add_compute_test("random.mersenne_twister_engine" test_mersenne_twister_engine.cpp)
+add_compute_test("random.threefry_engine" test_threefry_engine.cpp)
 add_compute_test("random.normal_distribution" test_normal_distribution.cpp)
 add_compute_test("random.uniform_int_distribution" test_uniform_int_distribution.cpp)
 add_compute_test("random.uniform_real_distribution" test_uniform_real_distribution.cpp)
 
-add_compute_test("types.builtin" test_types.cpp)
+add_compute_test("types.fundamental" test_types.cpp)
 add_compute_test("types.complex" test_complex.cpp)
 add_compute_test("types.pair" test_pair.cpp)
 add_compute_test("types.tuple" test_tuple.cpp)
@@ -178,80 +204,11 @@
 add_compute_test("experimental.malloc" test_malloc.cpp)
 add_compute_test("experimental.sort_by_transform" test_sort_by_transform.cpp)
 add_compute_test("experimental.tabulate" test_tabulate.cpp)
-add_compute_test("experimental.transform_if" test_transform_if.cpp)
-
-add_compute_test("ext.lambda" test_lambda.cpp)
-add_compute_test("ext.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)
-
-# eigen interop tests
-if(${BOOST_COMPUTE_HAVE_EIGEN})
-  find_package(Eigen REQUIRED)
-  include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
-  add_compute_test("interop.eigen" test_interop_eigen.cpp)
-endif()
-
-# opencv interop tests
-if(${BOOST_COMPUTE_HAVE_OPENCV})
-  find_package(OpenCV REQUIRED)
-  include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
-  add_compute_test("interop.opencv" test_interop_opencv.cpp)
-  target_link_libraries(test_interop_opencv ${OpenCV_LIBS})
-endif()
-
-# qt interop tests
-if(${BOOST_COMPUTE_HAVE_QT})
-  # look for Qt4 in the first place
-  find_package(Qt4 QUIET)
-
-  if(${QT4_FOUND})
-    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtOpenGL)
-    include(${QT_USE_FILE})
-  else()
-    find_package(Qt5Widgets QUIET)
-
-    # look for Qt5
-    if(${Qt5Widgets_FOUND})
-      find_package(Qt5Core REQUIRED)
-      find_package(Qt5Widgets REQUIRED)
-      find_package(Qt5OpenGL REQUIRED)
-      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5OpenGL_EXECUTABLE_COMPILE_FLAGS}")
-      set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})
-    else()
-      # no valid Qt framework found
-      message(FATAL_ERROR "Error: Did not find Qt4 or Qt5")
-    endif()
-  endif()
-
-  add_compute_test("interop.qt" test_interop_qt.cpp)
-  target_link_libraries(test_interop_qt ${QT_LIBRARIES})
-
-  # the opengl interop test depends on qt to create the opengl context
-  add_compute_test("interop.opengl" test_interop_opengl.cpp)
-  target_link_libraries(test_interop_opengl ${QT_LIBRARIES})
-endif()
-
-# vtk interop tests
-if(${BOOST_COMPUTE_HAVE_VTK})
-  find_package(VTK REQUIRED)
-  include(${VTK_USE_FILE})
-  add_compute_test("interop.vtk" test_interop_vtk.cpp)
-  target_link_libraries(test_interop_vtk ${VTK_LIBRARIES})
-endif()
-
-# tests for particular bugs/issues
-add_compute_test("issue.user_defined_types" test_user_defined_types.cpp)
-
-# Check for linkage problems
-add_executable(test_multiple_objects
-    test_multiple_objects1.cpp
-    test_multiple_objects2.cpp
-    )
-target_link_libraries(test_multiple_objects
-    ${OPENCL_LIBRARIES}
-    ${Boost_LIBRARIES}
-    )
-# link with coverage library
-if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  target_link_libraries(test_multiple_objects -fprofile-arcs -ftest-coverage)
-endif()
-add_test("issue.multiple_objects" test_multiple_objects)
+
+# miscellaneous tests
+add_compute_test("misc.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)
+add_compute_test("misc.lambda" test_lambda.cpp)
+add_compute_test("misc.user_defined_types" test_user_defined_types.cpp)
+
+# extra tests (interop tests, linkage tests, etc.)
+add_subdirectory(extra)
