=== debian/changelog ===
compute (0.5-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright:
    - Add corresponding entry for new files.
    - Apply `cme fix`, wrap and sort.
  * Drop fix-cmake-config-installdir.patch, applied upstream.
  * d/rules: generate missing Jamroot file for documentation.
  * Conditionally build examples and testsuite via nocheck.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 22 Dec 2015 00:22:36 +0000
