=== debian/control ===
--- 
+++ 
@@ -10,6 +10,8 @@
                docbook-xsl,
                doxygen,
                libboost-dev (>= 1.48),
+               libboost-program-options-dev (>= 1.48),
+               libboost-test-dev (>= 1.48),
                libboost-tools-dev,
                ocl-icd-opencl-dev | opencl-dev,
                xsltproc
