=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libboost-program-options-dev,
         libcompute-dev,
         libcompute-doc
Restrictions: allow-stderr
